# -*- coding: utf-8 -*-
import scrapy
from scrapy.linkextractors import LinkExtractor
from scrapy.spiders import CrawlSpider, Rule

class ChoutiSpider(CrawlSpider):
    name = 'chouti'
    # allowed_domains = ['dig.chouti.com']
    start_urls = ['https://dig.chouti.com/']
    #实例化链接提取器
    #链接提取器：根据正则表达式在页面中提取指定规则的链接
    link=LinkExtractor(allow=r'/all/hot/recent/\d+')
    rules = (
        #实例化一个规则解析器对象
        #规则解析器接收链接提取器发送的链接后，就会对这些链接发送请求，获取链接对应的页面内容，由callback回掉函数解析数据
        #follow参数：是否将链接提取器继续作用于链接提取器请求回的内容中，即递归
        Rule(link, callback='parse_item', follow=True),
    )

    def parse_item(self, response):
        item = {}
        #数据解析，和普通的spider一样
        print(response)
        #item['domain_id'] = response.xpath('//input[@id="sid"]/@value').get()
        #item['name'] = response.xpath('//div[@id="name"]').get()
        #item['description'] = response.xpath('//div[@id="description"]').get()
        return item
