# -*- coding: utf-8 -*-
import scrapy
class DoubandemoSpider(scrapy.Spider):
    name = 'doubanDemo'
    allowed_domains = ['www.douban.com']
    start_urls = ['https://accounts.douban.com/j/mobile/login/basic']

    #重写父类的start_requests方法，使其发送post请求
    def start_requests(self):
        #封装登陆信息
        data={
            "ck":"",
            "name":"用户名",
            "password":"密码",
            "remember":"false",
            "ticket":""
        }
        #通过FormRequest方法发送登陆请求
        for url in self.start_urls:
            yield scrapy.FormRequest(url=url,formdata=data,callback=self.parse)

    def parse(self, response):
        #登陆后先保存主页数据后请求获取个人主页数据
        fp=open("./index.html","w",encoding="utf-8")
        fp.write(response.text)
        fp.close()
        #个人主页url
        url="https://www.douban.com/people/191728538/"
        #这里会自动携带post请求之后的cookie参数
        yield scrapy.Request(url=url,callback=self.parseSecongPage)
    def parseSecongPage(self,response):
        #解析个人主页数据
        fp=open("./user_index.html","w",encoding="utf-8")
        fp.write(response.text)
        fp.close()
