# -*- coding: utf-8 -*-

# Define your item pipelines here
#
# Don't forget to add your pipeline to the ITEM_PIPELINES setting
# See: https://doc.scrapy.org/en/latest/topics/item-pipeline.html

#pipelines.py

#基于redis存储
# import redis
# class QiubaiproPipeline(object):
#     #编写想数据库中存储数据的相关代码
#     conn=None
#     #链接redis数据库
#     def open_spider(self,spider):
#         self.conn=redis.Redis(host="127.0.0.1",port=6379)
    
#     def process_item(self, item, spider):
#         data={
#             "author":item["author"],
#             "content":item["content"]
#         }
#         self.conn.lpush("qiubai",data)
#         return item
    
#     #关闭链接
#     def close_spider(self,spider):
#         self.conn.close()

#基于mysql存储
# import pymysql
# class QiubaiproPipeline(object):
#     #编写想数据库中存储数据的相关代码
#     conn=None
#     #链接数据库
#     def open_spider(self,spider):
#         self.conn=pymysql.Connect(host="127.0.0.1",port=3306,user="root",password="123456.com",db="qiubai")
    
#     def process_item(self, item, spider):
#         SQL="insert into qiubai values('%s','%s')" % (item['author'],item['content'])
        
#         self.cursor=self.conn.cursor()
#         try:
#             self.cursor.execute(sql)
#             self.conn.commit()
#         except Exception as e:
#             print(e)
#             self.conn.rollback()
#         return item
    
#     #关闭游标和链接
#     def close_spider(self,spider):
#         self.cursor.close()
#         self.conn.close()

#基于文件存储
# class QiubaiproPipeline(object):
#     fp=None
#     #在整个爬虫过程中，该方法只会在爬虫开始的时候调用一次
#     def open_spider(self,spider):
#         self.fp=open("./qiubai_pipe.txt","w",encoding="utf-8")
        
#     #接收爬虫文件提交过来的item对象，并且对item对象中存储的页面数据进行持久化操作
#     #参数：item：接收到的item对象
#     #每当爬虫给管道提交一次item，则该方法执行一次
#     def process_item(self, item, spider):
#         author=item["author"]
#         content=item["content"]
#         self.fp.write(author+":"+content+"\n\n\n")
    
#     #关闭爬虫会调用一次
#     def close_spider(self,spider):
#         self.fp.close()

#数据存储到本地文件中
class QiuBaiByFiles(object):
    def process_item(self, item, spider):
        print("写入到文件中")
        return item
    
#数据存储到MySQL数据库中
class QiuBaiByMysql(object):
    def process_item(self, item, spider):
        print("写入到MySQL中")
        return item
    
#数据存储到Redis数据库中
class QiuBaiByRedis(object):
    def process_item(self, item, spider):
        print("写入到Redis中")
        return item
    
    