# -*- coding: utf-8 -*-
import scrapy

#终端命令方式持久化存储
# class QiubaiSpider(scrapy.Spider):
#     name = 'qiubai'
#     #allowed_domains = ['www.qiushibaike.com']
#     start_urls = ['https://www.qiushibaike.com/text/']

#     def parse(self, response):
#         div_list=response.xpath("//div[@id='content-left']/div")
        
#         #用于返回可迭代器对象
#         data_list=[]
        
#         for div in div_list:
            
#             #xpath解析到的指定内容被存储到了selecter对象,可以用extract()方法提取数据值
#             #author=div.xpath("./div/a[2]/h2/text()").extract()[0]
            
#             #推荐使用extract_first()方法，extract()[0]会可能会出错，如没有获取到内容就会出现index错误
#             author=div.xpath("./div/a[2]/h2/text()").extract_first()
            
#             #非直系节点，用//
#             content=div.xpath(".//div[@class='content']/span/text()").extract()[0]
            
#             data_dict={
#                 "author":author,
#                 "content":content
#             }
#             data_list.append(data_dict)
#         return data_list
#基于pipelines方法持久化存储
# import scrapy
# from qiubaiPro.items import QiubaiproItem
# class QiubaiSpider(scrapy.Spider):
#     name = 'qiubai'
#     #allowed_domains = ['www.qiushibaike.com']
#     start_urls = ['https://www.qiushibaike.com/text/']

#     def parse(self, response):
#         div_list=response.xpath("//div[@id='content-left']/div")
        
#         for div in div_list:
#             #推荐使用extract_first()方法，extract()[0]会可能会出错，如没有获取到内容就会出现index错误
#             author=div.xpath("./div/a[2]/h2/text()").extract_first()
            
#             #非直系节点，用//
#             content=div.xpath(".//div[@class='content']/span/text()").extract()[0]
            
#             item=QiubaiproItem()
#             item["author"]=author
#             item["content"]=content
            
#             #将item对象用yield提交给管道文件
#             yield item
# 基于pipelines方法持久化存储
import scrapy
from qiubaiPro.items import QiubaiproItem
class QiubaiSpider(scrapy.Spider):
    name = 'qiubai'
    #allowed_domains = ['www.qiushibaike.com']
    start_urls = ['https://www.qiushibaike.com/text/']

    def parse(self, response):
        div_list=response.xpath("//div[@id='content-left']/div")
        
        for div in div_list:
            #推荐使用extract_first()方法，extract()[0]会可能会出错，如没有获取到内容就会出现index错误
            author=div.xpath("./div/a[2]/h2/text()").extract_first()
            
            #非直系节点，用//
            content=div.xpath(".//div[@class='content']/span/text()").extract()[0]
            
            item=QiubaiproItem()
            item["author"]=author
            item["content"]=content
            
            #将item对象用yield提交给管道
            yield item
    
            